﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Net;

using DsInstaller.model;

using DsShared;

namespace DsInstaller.behaviour
{
	// Perform the download operations on apps
	class Downloader
	{
		private NetworkCredential Credential = null;
        private DsShared.Status mStatus = null;

		public Downloader(NetworkCredential c, DsShared.Status status)
		{
			Credential = c;
            mStatus = status;
		}

		public void on(App a)
		{
			// Quietly reject anyone without a download source.
			// The error was reported earlier.
			if (string.IsNullOrEmpty(a.DownloadSource))
			{
				a.DownloadDestination = null;
				return;
			}

			string tmp = Path.GetTempFileName() + ".zip";
			if (string.IsNullOrEmpty(tmp))
			{
				return;
			}

            mStatus.WriteLine("Downloading to " + a.Local);
            string versionString = "";
            if (a.DownloadVersion != null)
            {
                versionString = a.DownloadVersion.ToString();
            }
            mStatus.WriteLine("\tversion " + versionString);

            DsShared.NetUtil.FtpDownloadFile(Credential, a.DownloadSource, tmp, mStatus);
			a.DownloadDestination = tmp;
		}
	}
}
