﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;

using DsShared;

namespace DsInstaller.model
{
	class App
	{
		public string Remote { get; private set; }
		public string Local { get; private set; }
		// The version that I'm requesting to install.  Will be empty for "latest"
		public string Version { get; private set; }

		// Installing is a two-step process:  First identify a file on the
		// server we want to install (the download source), then download it
		// to a local location (the download destination).
		public string DownloadSource { get; set; }
		public string DownloadDestination { get; set; }
        // The version I'm downloading
        public DsShared.Version DownloadVersion { get; set; }

		public bool ReadXmlFrom(XmlTextReader reader)
		{
			if (reader.Name != "app")
			{
				return false;
			}

			while (reader.MoveToNextAttribute()) // Read the attributes.
			{
				if (reader.Name == "remote")
				{
					Remote = reader.Value;
				}
				else if (reader.Name == "local")
				{
					Local = reader.Value;
				}
				else if (reader.Name == "version")
				{
					Version = reader.Value;
				}
			}
			Local = DsShared.Util.ExpandMacros(Local);
			return !(string.IsNullOrEmpty(Remote) || string.IsNullOrEmpty(Local));
		}
	}
}
