﻿using System;
using System.Collections.Generic;
using System.Net;
using System.Text;
using System.Threading;

using DsUploader.behaviour;
using DsUploader.model;
using DsShared;

// Includes this project:
// http://dotnetzip.codeplex.com/

namespace ds_packager
{
	class Program
	{
		static void Main(string[] args)
		{
			DsShared.NetUtil.initialize();

			NetworkCredential credential = DsShared.NetUtil.Credential;
            DsShared.Status status = new DsShared.Status();
            
            string[] input = args;
            // debugging
//			input = new string[1] { @"C:\work\downstream\ds_release_manager\docs\examples\packager_example.xml" };
            Package[] packages = Package.ReadXmlAllFrom(input);
			if (packages == null || packages.Length < 1)
			{
				status.WriteLine("no input");
				return;
			}

			// Upload each app
			Uploader uploader = new Uploader(credential, status);
			forEachApp(packages, a => uploader.on(a));

			Console.WriteLine("uploader finished");
			Thread.Sleep(5000);
		}

		// Perform an action on each app in each package
		static private void forEachApp(Package[] packages, Action<App> f)
		{
			foreach (Package p in packages)
			{
				if (p != null)
				{
					foreach (App a in p.mApp)
					{
						f.Invoke(a);
					}
				}
			}
		}
	}
}
