﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using System.Xml;

using DsShared;

namespace DsUploader.model
{
	class App
	{
		public string Remote { get; set; }
		public string Local { get; set; }

		private static string DOCUMENTS = @"$Documents";

		public bool ReadXmlFrom(XmlTextReader reader, string parentPath)
		{
			if (reader.Name != "app")
			{
				return false;
			}

			while (reader.MoveToNextAttribute()) // Read the attributes.
			{
				if (reader.Name == "remote")
				{
					Remote = reader.Value;
				}
				else if (reader.Name == "local")
				{
					Local = reader.Value;
				}
			}
			Local = DsShared.Util.ExpandMacros(Local);
			if (!Path.IsPathRooted(Local)) {
				Local = Path.Combine(parentPath, Local);
			}
			if (!Directory.Exists(Local))
			{
				Local = "";
			}
			bool ans = (!(string.IsNullOrEmpty(Remote) || string.IsNullOrEmpty(Local)));
			if (!ans)
			{
				Console.WriteLine("invalid input for app (remote=" + Remote + " local=" + Local + ")");
			}
			// Make sure the path separator is in the OS standard and we've expanded any relative parts
			Local = Path.GetFullPath(Local);
			return ans;
		}
	}
}
