﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Xml;

namespace DsUploader.model
{
	class Package
	{
		public List<App> mApp = new List<App>();

		// Answer a collection of packages
		static public Package[] ReadXmlAllFrom(string[] filenames)
		{
			List<Package> list = new List<Package>();
			foreach (string filename in filenames)
			{
				Package p = ReadXmlFrom(filename);
				if (p != null)
				{
					list.Add(p);
				}
			}
			return list.ToArray();
		}

		static public Package ReadXmlFrom(string filename)
		{
			XmlTextReader reader = new XmlTextReader(filename);
			string parent = Directory.GetParent(filename).FullName;

			// Just skip xmls that are the wrong type
			if (!reader.Read() || reader.Name != "package")
			{
				return null;
			}

			Package p = new Package();
			while (reader.Read())
			{
				switch (reader.NodeType)
				{
					case XmlNodeType.Element: // The node is an element.
						if (reader.Name == "app")
						{
							App app = new App();
							if (app.ReadXmlFrom(reader, parent))
							{
								p.mApp.Add(app);
							}
						}
						break;
				}
			}
			return p;
		}
	}
}
