﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Net;

namespace DsShared
{
	public class Util
	{
		// XML file macros
		private static string APPS_MACRO = @"$Apps";			// Downstream app install folder
		private static string DOCUMENTS_MACRO = @"$Documents";	// user My Documents

		// Convert a version into a standard file name
		public static string getFilenameFromVersion(string version)
		{
			return version.Replace(".", "_");
		}

		// The local probably has a special macro token, so resolve that
		// to a real path, if posible.
		public static string ExpandMacros(string path)
		{
			if (path.StartsWith(APPS_MACRO))
			{
				string apps = Environment.GetFolderPath(Environment.SpecialFolder.ProgramFilesX86);
				path = Path.Combine(apps, path.Substring(APPS_MACRO.Length + 1));
			}
			else if (path.StartsWith(DOCUMENTS_MACRO))
			{
				string myDocs = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments);
				path = Path.Combine(myDocs, path.Substring(DOCUMENTS_MACRO.Length + 1));
			}

			// Make sure the path separator is in the OS standard
			if (!string.IsNullOrEmpty(path) && Path.IsPathRooted(path))
			{
				path = Path.GetFullPath(path);
			}
			return path;
		}
	}
}
